/*ChargTran fill in the HCharExcIon and Rec arrays with Kingdon's fitted CT with H */
void ChargTranEval( void );

/* sum up the charge transfer heating */
double SumCTHeat(void);

/*HCTion H charge transfer ionization, H+ + A => H + A+ */
double HCTIon(long int ion, 
  long int nelem);

/*HCTRecom H charge transfer recombination, H + A+ => H+ + A */
double HCTRecom(long int ion, 
  long int nelem);

/* punch charge transfer rate coefficients */
void ChargTranPun( FILE* ipPnunit , char* chPunch );

EXTERN struct t_CharExc {
	/*
	 * ion, nelem
	 * these arrays save the charge transfer ionization and recom
	 * rates for the heavy elements onto hydrogen.  ionization is
	 * of the heavy element, and so is a recom for hydrogen
	 * 
	 * HCharExcIon( ion , nelem ), HCharExcRec( ion , nelem )
	 * charge transfer ionization of atomic oxygen = HCharExcIon(1,8)*hii
	 * charge transfer recombination of ionized oxygen = HCharExcRec(1,8)*hi
	 * HCharHeatMax, HCharCoolMax are largest fractions of local heating
	 * or cooling due to ct
	 * HCharHeatOn usually 1, set to 0 with no CTHeat command
	 */
	float HCharExcIon[LIMELM][LIMELM], 
	  HCharExcRec[LIMELM][LIMELM], 
	  HCharHeatMax, 
	  HCharCoolMax, 
	  HCharHeatOn;

	/* first cell of vector is current value of ioniz/rec of elements
	 * sec is lagging value, average of current and old
	 * CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
	 * CTHion is same for ct ionization of hydrogen
	 * chrener is energy exchange in Ryd */
	float CTHion[2][2], 
	  CTHrec[2][2], 
	  chrener, 
	  chrexCool, 
	  CTHionAgnt[5];

	/*
	 *this is the charge ionization, recom array
	 *that goes into the ionization balance
	 *Ion[ion] is ionization, Rec[ion] is recombination
	 *it has all He charge transfer rates
	 */
	float HeCharExcIon[LIMELM][LIMELM], 
	  HeCharExcRec[LIMELM][LIMELM];

	/* Dalgarno H charge transfer rate coef for high stages of ionization
	 * default is 1.92e-9 in zero, reset with 'set charge transfer' command */
	float HCTAlex;

	/* variable to turn on or off ct ionization-recombiantion of
	 * hydrogen - set 0 with no charge trasnfer command */
	float HCTOn;

	}	ChargTran;
