/*csphot returns photoionization cross section from opacity stage using std pointers */
#include "cddefines.h"
#include "opacity.h"
#include "csphot.h"

/* function to facilitate addressing opacity array */
double csphot(
	/* INU is array index pointing to frequency where opacity is to be evaluated
	 * on f not c scale */
	long int inu, 
	/* ITHR is pointer to threshold*/
	long int ithr, 
	/* IOFSET is offset as defined in opac0*/
	long int iofset)
{
	double csphot_v;

#	ifdef DEBUG_FUN
	fputs( "<+>csphot()\n", debug_fp );
#	endif

	csphot_v = opac.OpacStack[inu-ithr+iofset-1];

#	ifdef DEBUG_FUN
	fputs( " <->csphot()\n", debug_fp );
#	endif
	return( csphot_v );
}

