/* incidspec.h */
/*
 *     parameters to do with incident continuum
 *
 *     limit to number of spectra that can be entered
 */
#define	LIMSPC	10

EXTERN struct t_IncidSpec {
	double totpow[LIMSPC], 
	  slope[LIMSPC], 
	  cutoff[3][LIMSPC], 
	  spfac[LIMSPC];
	long int nspec, 
	  ipspec;

	/* these are used for interpolate and table commands, 
	 * this is the linear energy Rydbergs of continuum point */
	double tNuRyd[NCELL][LIMSPC], 
	  tslop[NCELL][LIMSPC], 
	  /* this is the log of f_nu of continuum point */
	  tFluxLog[NCELL][LIMSPC], 

	  /* range for particular continuum source */
	  range[2][LIMSPC];

	}	IncidSpec;

EXTERN struct t_spnorm {
/* chSpNorm says how spectrum was normlized - are or lum
 * chrspec says whether per unit anea or tot 4 pi  */
	char chSpNorm[LIMSPC][5], 
	  chRSpec[LIMSPC][5], 
	  chSpType[LIMSPC][6];

	/* pointer to file for table read command, only 1 possible */
	FILE *ioTableRead[LIMSPC];

	}	spnorm;

