/* ionrange.h */
EXTERN struct t_IonRange {

	/*
	 * indices for lowest and highest stages of ionization of the elements
	 * all are initially set in nsset
	 * the range is from 0 to nelem +1 
	 */

	/* indices for lowest stage of ionization of the elements on C scale, 
	 * lowest is 0 for atom, -1 if element turned off */
	long int IonLow[LIMELM], 

	  /* indices for highest stage of ionization of the elements, initially ipZ+1 */
	  IonHigh[LIMELM], 

	  /* also places to save them between iterations */
	  IonLowSave[LIMELM], 
	  IonHighSave[LIMELM];

	/* flag saying not to decrement this range */
	int lgNoDec;

	}	IonRange;

