/*ParseEscP parse escape probability command, to determine which treatment to use for
 * subordinate lines - their escape probabilities are evaluated in  */
#include "cddefines.h"
#include "rt.h"
#include "parse.h"

void ParseEscP(char *chCard )
{
	char chKey[5];

#	ifdef DEBUG_FUN
	fputs( "<+>ParseEscP()\n", debug_fp );
#	endif

	/* escape probability function for subordinate lines */
	if( lgMatch(" K2 ",chCard) )
	{
		strcpy( chKey, "  K2" );
	}
	else if( lgMatch("INCO",chCard) )
	{
		strcpy( chKey, "INCO" );
	}
	else if( lgMatch("SIMP",chCard) )
	{
		strcpy( chKey, "SIMP" );
	}
	/* this is the default, complete redistribution with wings. */
	else if( lgMatch(" CRD",chCard) )
	{
		strcpy( chKey, "CRDW" );
	}
	else
	{
		fprintf( ioQQQ, 
			" Subordinate escape probability must be either SIMP, K2 , CRD, or COMP.  Sorry.\n" );
		puts( "[Stop in ParseEscP]" );
		cdEXIT(1);
	}

	if( lgMatch("EMIT",chCard) )
	{
		strcpy( rt.chEscFunSubord, chKey );
	}
	else if( lgMatch("DEST",chCard) )
	{
		strcpy( rt.chDstFun, chKey );
	}
	else
	{
		strcpy( rt.chEscFunSubord, chKey );
		strcpy( rt.chDstFun, chKey );
	}


#	ifdef DEBUG_FUN
	fputs( " <->ParseEscP()\n", debug_fp );
#	endif
	return;
}

