/*escinc fundamental escape probability radiative transfer routine for incomplete redistribution */
double escinc(double tau, 
  double a);

/*esccom fundamental escape probability radiative transfer routine, for complete redistribution */
double esccom(double tau, 
  double a);

/*escla escape prob for hydrogen atom Lya, using Hummer and Kunasz results */
double escla(float *esin, 
  float *dest, 
  double abund, 
  long int ipZ);/* 0 for H, */

/*escsub escape probability radiative transfer for subordinate lines */
double escsub(double tau, 
  double tout, 
  double damp);

/*esc_CRDwing escape probability CRD with wings, for subordinate lines */
double esc_CRDwing(double tau, 
  double tout, 
  double damp);

/*esc_CRDcore escape probability CRD with no wings, for subordinate lines */
double esc_CRDcore(double tau, 
  double tout);

/*escgrd escape probability radiative transfer for incomplete redistribution */
double escgrd(double tau, 
  double tout, 
  double damp );

/*esca0k2 derive Hummer's K2 escape probability for Doppler core only */
double esca0k2(double taume);

/*escpcn continuum escape probability */
double esccon(double tau, 
  double hnukt);

/*conesc one of the forms of the continuum escape probability */
double escConE2(double x);

/*eovrlp returns line destruction probability due to continuum opacity */
double eovrlp(
	  /* abundance of species */
	  double abund, 
	  /* its line absorption cross section */
	  double crsec, 
	  /* pointer to energy within continuum array, to get background opacity,
	   * this is on the f not c scale */
	  long int ipanu, 
	  /* line width */
	  double widl, 
	  /* escape probability */
	  double escp, 
	  /* type of redistribution function */
	  char *chCore);
