/*
 * these save EXTERN structure variables, like te vs depth
 * zeroed out in zero, incremented in RTOptDepthIncre
 */

/* limit to how many zones we can remember */
#define	NZLIM	600

EXTERN struct t_struc {
	float testr[NZLIM], 
	  volstr[NZLIM], 
	  radstr[NZLIM], 
	  histr[NZLIM], 
	  hiistr[NZLIM], 
	  ednstr[NZLIM], 
	  o3str[NZLIM], 
	  /* total grams per unit vol */
	  pdenstr[NZLIM] ,
	  pressure[NZLIM],
	  /* density, gm/cm3 */
	  DenMass[NZLIM],
	  /* depth of this position */
	  depth[NZLIM],
	  /* Lyman continuum optical depth for current iteration */
	  xLyman_depth[NZLIM],
	  /* sum of enthalpy and kinetic energy per gram */
	  work[NZLIM];

	/* HI ionization structure from previous iteration */
	float Old_histr[NZLIM] ,
		/* Lyman continuum optical depth from previous iteration */
		Old_xLyman_depth[NZLIM],
		/* depth of position in previous iteration */
		Old_depth[NZLIM],
		/* old n_p density from previous iteration */
		Old_hiistr[NZLIM],
		/* old pressure from previous iteration */
		Old_pressure[NZLIM],
		/* density - total grams per unit vol */
	    Old_pdenstr[NZLIM] ,
		/* old electron density from previous iteration */
		Old_ednstr[NZLIM],
	    /* sum of enthalpy and kinetic energy per gram */
	    Old_work[NZLIM];

	/* save ionization balance array across model */
	float ***xIonFracs ;
	/* the ionization fractions from the previous iteration */
	float ***Old_xIonFracs;

	/* the number of zones that were saved in the previous iteration */
	long int nOld_zone;

	  /* cooling and heating for each zone */
	double coolstr[NZLIM] ,
	  heatstr[NZLIM];
	}	struc;

